/*
 * Copyright (c) 2014 Ziver
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.plugin.apache;

import wa.server.plugin.*;
import zutil.log.LogUtil;

import java.util.logging.Logger;

/**
 * Created by Ziver on 2014-12-23.
 */
public class ApacheService implements WAService {
    private static Logger log = LogUtil.getLogger();
    public static final String SERVICE_NAME = "Apache2";

    private ApacheStatus status;
    private ApacheInstaller installer;
    private WAServiceConfig[] config;

    @Override
    public String getName() {
        return SERVICE_NAME;
    }

    @Override
    public WAServiceStatus getStatus() {
        if(status == null)
            status = new ApacheStatus();
        return status;
    }

    @Override
    public WALog getLog() {
        return null;
    }

    @Override
    public WAInstaller getInstaller() {
        if(installer == null)
            installer = new ApacheInstaller();
        return installer;
    }

    @Override
    public WAServiceConfig[] getConfigurations() {
        if(config == null)
            config = new WAServiceConfig[]{
                    //new ApacheConfigVirtualHost()
            };
        return config;
    }
}
